Index: serefpolicy-contrib-20140730/razor.te
===================================================================
--- serefpolicy-contrib-20140730.orig/razor.te
+++ serefpolicy-contrib-20140730/razor.te
@@ -5,135 +5,124 @@ policy_module(razor, 2.4.0)
 # Declarations
 #
 
-attribute razor_domain;
-
-attribute_role razor_roles;
-
-type razor_exec_t;
-corecmd_executable_file(razor_exec_t)
-
-type razor_etc_t;
-files_config_file(razor_etc_t)
-
-type razor_home_t;
-typealias razor_home_t alias { user_razor_home_t staff_razor_home_t sysadm_razor_home_t };
-typealias razor_home_t alias { auditadm_razor_home_t secadm_razor_home_t };
-userdom_user_home_content(razor_home_t)
-
-type razor_log_t;
-logging_log_file(razor_log_t)
-
-type razor_tmp_t;
-typealias razor_tmp_t alias { user_razor_tmp_t staff_razor_tmp_t sysadm_razor_tmp_t };
-typealias razor_tmp_t alias { auditadm_razor_tmp_t secadm_razor_tmp_t };
-userdom_user_tmp_file(razor_tmp_t)
-
-type razor_var_lib_t;
-files_type(razor_var_lib_t)
-
-razor_common_domain_template(razor)
-typealias razor_t alias { user_razor_t staff_razor_t sysadm_razor_t };
-typealias razor_t alias { auditadm_razor_t secadm_razor_t };
-userdom_user_application_type(razor_t)
-role razor_roles types razor_t;
-
-razor_common_domain_template(system_razor)
-role system_r types system_razor_t;
-
-########################################
-#
-# Common razor domain local policy
-#
-
-allow razor_domain self:process ~{ ptrace setcurrent setexec setfscreate setrlimit execmem execstack execheap };
-allow razor_domain self:fd use;
-allow razor_domain self:fifo_file rw_fifo_file_perms;
-allow razor_domain self:unix_dgram_socket sendto;
-allow razor_domain self:unix_stream_socket { accept connectto listen };
-
-allow razor_domain razor_etc_t:dir list_dir_perms;
-allow razor_domain razor_etc_t:file read_file_perms;
-allow razor_domain razor_etc_t:lnk_file read_lnk_file_perms;
-
-allow razor_domain razor_exec_t:file read_file_perms;
-allow razor_domain razor_exec_t:lnk_file read_lnk_file_perms;
-
-kernel_read_system_state(razor_domain)
-kernel_read_network_state(razor_domain)
-kernel_read_software_raid_state(razor_domain)
-kernel_getattr_core_if(razor_domain)
-kernel_getattr_message_if(razor_domain)
-kernel_read_kernel_sysctls(razor_domain)
-
-corecmd_exec_bin(razor_domain)
-
-corenet_all_recvfrom_unlabeled(razor_domain)
-corenet_all_recvfrom_netlabel(razor_domain)
-corenet_tcp_sendrecv_generic_if(razor_domain)
-corenet_tcp_sendrecv_generic_node(razor_domain)
-
-corenet_tcp_sendrecv_razor_port(razor_domain)
-corenet_tcp_connect_razor_port(razor_domain)
-corenet_sendrecv_razor_client_packets(razor_domain)
-
-dev_read_rand(razor_domain)
-dev_read_urand(razor_domain)
-
-files_read_etc_runtime_files(razor_domain)
-
-libs_read_lib_files(razor_domain)
-
-miscfiles_read_localization(razor_domain)
-
-########################################
-#
-# System local policy
-#
-
-manage_dirs_pattern(system_razor_t, razor_etc_t, razor_etc_t)
-manage_files_pattern(system_razor_t, razor_etc_t, razor_etc_t)
-manage_lnk_files_pattern(system_razor_t, razor_etc_t, razor_etc_t)
-
-manage_dirs_pattern(system_razor_t, razor_log_t, razor_log_t)
-append_files_pattern(system_razor_t, razor_log_t, razor_log_t)
-create_files_pattern(system_razor_t, razor_log_t, razor_log_t)
-setattr_files_pattern(system_razor_t, razor_log_t, razor_log_t)
-manage_lnk_files_pattern(system_razor_t, razor_log_t, razor_log_t)
-logging_log_filetrans(system_razor_t, razor_log_t, file)
-
-manage_dirs_pattern(system_razor_t, razor_var_lib_t, razor_var_lib_t)
-manage_files_pattern(system_razor_t, razor_var_lib_t, razor_var_lib_t)
-manage_lnk_files_pattern(system_razor_t, razor_var_lib_t, razor_var_lib_t)
-files_var_lib_filetrans(system_razor_t, razor_var_lib_t, file)
-
-########################################
-#
-# Session local policy
-#
-
-manage_dirs_pattern(razor_t, razor_home_t, razor_home_t)
-manage_files_pattern(razor_t, razor_home_t, razor_home_t)
-manage_lnk_files_pattern(razor_t, razor_home_t, razor_home_t)
-userdom_user_home_dir_filetrans(razor_t, razor_home_t, dir, ".razor")
-
-manage_dirs_pattern(razor_t, razor_tmp_t, razor_tmp_t)
-manage_files_pattern(razor_t, razor_tmp_t, razor_tmp_t)
-files_tmp_filetrans(razor_t, razor_tmp_t, { file dir })
-
-fs_getattr_all_fs(razor_t)
-fs_search_auto_mountpoints(razor_t)
-
-userdom_use_unpriv_users_fds(razor_t)
-userdom_use_user_terminals(razor_t)
-
-tunable_policy(`use_nfs_home_dirs',`
-	fs_manage_nfs_dirs(razor_t)
-	fs_manage_nfs_files(razor_t)
-	fs_manage_nfs_symlinks(razor_t)
-')
-
-tunable_policy(`use_samba_home_dirs',`
-	fs_manage_cifs_dirs(razor_t)
-	fs_manage_cifs_files(razor_t)
-	fs_manage_cifs_symlinks(razor_t)
+ifdef(`distro_redhat',`
+	gen_require(`
+		type spamc_t, spamc_exec_t, spamd_log_t;
+		type spamd_spool_t, spamd_var_lib_t, spamd_etc_t;
+		type spamc_home_t, spamc_tmp_t;
+	')
+
+	typealias spamc_t alias razor_t;
+	typealias spamc_exec_t alias razor_exec_t;
+	typealias spamd_log_t alias razor_log_t;
+	typealias spamd_var_lib_t alias razor_var_lib_t;
+	typealias spamd_etc_t alias razor_etc_t;
+	typealias spamc_home_t alias razor_home_t;
+	typealias spamc_home_t alias { user_razor_home_t staff_razor_home_t sysadm_razor_home_t };
+	typealias spamc_home_t alias { auditadm_razor_home_t secadm_razor_home_t };
+	typealias spamc_tmp_t alias { user_razor_tmp_t staff_razor_tmp_t sysadm_razor_tmp_t };
+	typealias spamc_tmp_t alias { auditadm_razor_tmp_t secadm_razor_tmp_t };
+',`
+	type razor_exec_t;
+	corecmd_executable_file(razor_exec_t)
+
+	type razor_etc_t;
+	files_config_file(razor_etc_t)
+
+	type razor_home_t;
+	typealias razor_home_t alias { user_razor_home_t staff_razor_home_t sysadm_razor_home_t };
+	typealias razor_home_t alias { auditadm_razor_home_t secadm_razor_home_t };
+	userdom_user_home_content(razor_home_t)
+
+	type razor_log_t;
+	logging_log_file(razor_log_t)
+
+	type razor_tmp_t;
+	typealias razor_tmp_t alias { user_razor_tmp_t staff_razor_tmp_t sysadm_razor_tmp_t };
+	typealias razor_tmp_t alias { auditadm_razor_tmp_t secadm_razor_tmp_t };
+	files_tmp_file(razor_tmp_t)
+	ubac_constrained(razor_tmp_t)
+
+	type razor_var_lib_t;
+	files_type(razor_var_lib_t)
+
+	# these are here due to ordering issues:
+	razor_common_domain_template(razor)
+	typealias razor_t alias { user_razor_t staff_razor_t sysadm_razor_t };
+	typealias razor_t alias { auditadm_razor_t secadm_razor_t };
+	ubac_constrained(razor_t)
+
+	razor_common_domain_template(system_razor)
+	role system_r types system_razor_t;
+
+	########################################
+	#
+	# System razor local policy
+	#
+
+	# this version of razor is invoked typically
+	# via the system spam filter
+
+	allow system_razor_t self:tcp_socket create_socket_perms;
+
+	manage_dirs_pattern(system_razor_t, razor_etc_t, razor_etc_t)
+	manage_files_pattern(system_razor_t, razor_etc_t, razor_etc_t)
+	manage_lnk_files_pattern(system_razor_t, razor_etc_t, razor_etc_t)
+	files_search_etc(system_razor_t)
+
+	allow system_razor_t razor_log_t:file manage_file_perms;
+	logging_log_filetrans(system_razor_t, razor_log_t, file)
+
+	manage_files_pattern(system_razor_t, razor_var_lib_t, razor_var_lib_t)
+	files_var_lib_filetrans(system_razor_t, razor_var_lib_t, file)
+
+	corenet_all_recvfrom_netlabel(system_razor_t)
+	corenet_tcp_sendrecv_generic_if(system_razor_t)
+	corenet_raw_sendrecv_generic_if(system_razor_t)
+	corenet_tcp_sendrecv_generic_node(system_razor_t)
+	corenet_raw_sendrecv_generic_node(system_razor_t)
+	corenet_tcp_sendrecv_razor_port(system_razor_t)
+	corenet_tcp_connect_razor_port(system_razor_t)
+	corenet_sendrecv_razor_client_packets(system_razor_t)
+
+	auth_use_nsswitch(system_razor_t)
+
+	# cjp: this shouldn't be needed
+	userdom_use_unpriv_users_fds(system_razor_t)
+
+	optional_policy(`
+		logging_send_syslog_msg(system_razor_t)
+	')
+
+	########################################
+	#
+	# User razor local policy
+	#
+
+	# Allow razor to be run by hand.  Needed by any action other than
+	# invocation from a spam filter.
+
+	allow razor_t self:unix_stream_socket create_stream_socket_perms;
+
+	manage_dirs_pattern(razor_t, razor_home_t, razor_home_t)
+	manage_files_pattern(razor_t, razor_home_t, razor_home_t)
+	manage_lnk_files_pattern(razor_t, razor_home_t, razor_home_t)
+	userdom_user_home_dir_filetrans(razor_t, razor_home_t, dir)
+
+	manage_dirs_pattern(razor_t, razor_tmp_t, razor_tmp_t)
+	manage_files_pattern(razor_t, razor_tmp_t, razor_tmp_t)
+	files_tmp_filetrans(razor_t, razor_tmp_t, { file dir })
+
+	auth_use_nsswitch(razor_t)
+
+	logging_send_syslog_msg(razor_t)
+
+	userdom_search_user_home_dirs(razor_t)
+	userdom_use_inherited_user_terminals(razor_t)
+
+	userdom_home_manager(razor_t)
+
+	optional_policy(`
+		milter_manage_spamass_state(razor_t)
+	')
 ')
Index: serefpolicy-contrib-20140730/rdisc.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/rdisc.fc
+++ serefpolicy-contrib-20140730/rdisc.fc
@@ -1,3 +1,3 @@
-/sbin/rdisc	--	gen_context(system_u:object_r:rdisc_exec_t,s0)
+/usr/lib/systemd/system/rdisc.*         --      gen_context(system_u:object_r:rdisc_unit_file_t,s0)
 
 /usr/sbin/rdisc	--	gen_context(system_u:object_r:rdisc_exec_t,s0)
Index: serefpolicy-contrib-20140730/rdisc.if
===================================================================
--- serefpolicy-contrib-20140730.orig/rdisc.if
+++ serefpolicy-contrib-20140730/rdisc.if
@@ -18,3 +18,57 @@ interface(`rdisc_exec',`
 	corecmd_search_bin($1)
 	can_exec($1, rdisc_exec_t)
 ')
+
+########################################
+## <summary>
+##      Execute rdisc server in the rdisc domain.
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed to transition.
+##      </summary>
+## </param>
+#
+interface(`rdisc_systemctl',`
+        gen_require(`
+                type rdisc_t;
+                type rdisc_unit_file_t;
+        ')
+
+        systemd_exec_systemctl($1)
+        systemd_read_fifo_file_passwd_run($1)
+        allow $1 rdisc_unit_file_t:file read_file_perms;
+        allow $1 rdisc_unit_file_t:service manage_service_perms;
+
+        ps_process_pattern($1, rdisc_t)
+')
+
+########################################
+## <summary>
+##      All of the rules required to administrate
+##      an rdisc environment
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+## <rolecap/>
+#
+interface(`rdisc_admin',`
+        gen_require(`
+            type rdisc_t;
+            type rdisc_unit_file_t;
+        ')
+
+        allow $1 rdisc_t:process { ptrace signal_perms };
+        ps_process_pattern($1, rdisc_t)
+
+        rdisc_systemctl($1)
+        admin_pattern($1, rdisc_unit_file_t)
+        allow $1 rdisc_unit_file_t:service all_service_perms;
+        optional_policy(`
+                systemd_passwd_agent_exec($1)
+                systemd_read_fifo_file_passwd_run($1)
+        ')
+')
Index: serefpolicy-contrib-20140730/rdisc.te
===================================================================
--- serefpolicy-contrib-20140730.orig/rdisc.te
+++ serefpolicy-contrib-20140730/rdisc.te
@@ -9,6 +9,9 @@ type rdisc_t;
 type rdisc_exec_t;
 init_daemon_domain(rdisc_t, rdisc_exec_t)
 
+type rdisc_unit_file_t;
+systemd_unit_file(rdisc_unit_file_t)
+
 ########################################
 #
 # Local policy
@@ -25,7 +28,6 @@ kernel_list_proc(rdisc_t)
 kernel_read_proc_symlinks(rdisc_t)
 kernel_read_kernel_sysctls(rdisc_t)
 
-corenet_all_recvfrom_unlabeled(rdisc_t)
 corenet_all_recvfrom_netlabel(rdisc_t)
 corenet_udp_sendrecv_generic_if(rdisc_t)
 corenet_raw_sendrecv_generic_if(rdisc_t)
@@ -39,12 +41,9 @@ fs_search_auto_mountpoints(rdisc_t)
 
 domain_use_interactive_fds(rdisc_t)
 
-files_read_etc_files(rdisc_t)
 
 logging_send_syslog_msg(rdisc_t)
 
-miscfiles_read_localization(rdisc_t)
-
 sysnet_read_config(rdisc_t)
 
 userdom_dontaudit_use_unpriv_user_fds(rdisc_t)
Index: serefpolicy-contrib-20140730/readahead.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/readahead.fc
+++ serefpolicy-contrib-20140730/readahead.fc
@@ -1,7 +1,11 @@
-/sbin/readahead.*	--	gen_context(system_u:object_r:readahead_exec_t,s0)
+/dev/\.systemd/readahead(/.*)?	gen_context(system_u:object_r:readahead_var_run_t,s0)
 
+/sbin/readahead.*	--	gen_context(system_u:object_r:readahead_exec_t,s0)
 /usr/sbin/readahead.*	--	gen_context(system_u:object_r:readahead_exec_t,s0)
 
+/usr/lib/systemd/systemd-readahead.*	--	gen_context(system_u:object_r:readahead_exec_t,s0)
+
 /var/lib/readahead(/.*)?	gen_context(system_u:object_r:readahead_var_lib_t,s0)
 
+/var/run/systemd/readahead(/.*)?  gen_context(system_u:object_r:readahead_var_run_t,s0)
 /var/run/readahead.*	gen_context(system_u:object_r:readahead_var_run_t,s0)
Index: serefpolicy-contrib-20140730/readahead.if
===================================================================
--- serefpolicy-contrib-20140730.orig/readahead.if
+++ serefpolicy-contrib-20140730/readahead.if
@@ -19,3 +19,27 @@ interface(`readahead_domtrans',`
 	corecmd_search_bin($1)
 	domtrans_pattern($1, readahead_exec_t, readahead_t)
 ')
+
+########################################
+## <summary>
+##	Manage readahead var_run files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`readahead_manage_pid_files',`
+	gen_require(`
+		type readahead_var_run_t;
+	')
+
+	manage_dirs_pattern($1, readahead_var_run_t, readahead_var_run_t)
+	manage_files_pattern($1, readahead_var_run_t, readahead_var_run_t)
+	dev_filetrans($1, readahead_var_run_t, { dir  file })
+	init_pid_filetrans($1, readahead_var_run_t, { dir file })
+	files_search_pids($1)	
+	init_search_pid_dirs($1)
+')
+
Index: serefpolicy-contrib-20140730/readahead.te
===================================================================
--- serefpolicy-contrib-20140730.orig/readahead.te
+++ serefpolicy-contrib-20140730/readahead.te
@@ -1,4 +1,4 @@
-policy_module(readahead, 1.13.1)
+policy_module(readahead, 1.13.0)
 
 ########################################
 #
@@ -15,7 +15,8 @@ typealias readahead_var_lib_t alias read
 
 type readahead_var_run_t;
 files_pid_file(readahead_var_run_t)
-init_daemon_pid_file(readahead_var_run_t, dir, "readahead")
+dev_associate(readahead_var_run_t)
+init_daemon_run_dir(readahead_var_run_t, "readahead")
 
 ########################################
 #
@@ -31,13 +32,18 @@ manage_files_pattern(readahead_t, readah
 
 manage_dirs_pattern(readahead_t, readahead_var_run_t, readahead_var_run_t)
 manage_files_pattern(readahead_t, readahead_var_run_t, readahead_var_run_t)
+dev_filetrans(readahead_t, readahead_var_run_t, { dir file })
 files_pid_filetrans(readahead_t, readahead_var_run_t, { dir file })
 
 kernel_read_all_sysctls(readahead_t)
 kernel_read_system_state(readahead_t)
 kernel_dontaudit_getattr_core_if(readahead_t)
+kernel_list_all_proc(readahead_t)
 
-dev_read_sysfs(readahead_t)
+dev_rw_sysfs(readahead_t)
+dev_read_kmsg(readahead_t)
+dev_read_urand(readahead_t)
+dev_write_kmsg(readahead_t)
 dev_getattr_generic_chr_files(readahead_t)
 dev_getattr_generic_blk_files(readahead_t)
 dev_getattr_all_chr_files(readahead_t)
@@ -51,12 +57,22 @@ domain_use_interactive_fds(readahead_t)
 domain_read_all_domains_state(readahead_t)
 
 files_create_boot_flag(readahead_t)
+files_delete_root_files(readahead_t)
 files_getattr_all_pipes(readahead_t)
 files_list_non_security(readahead_t)
 files_read_non_security_files(readahead_t)
 files_search_var_lib(readahead_t)
 files_dontaudit_getattr_all_sockets(readahead_t)
 files_dontaudit_getattr_non_security_blk_files(readahead_t)
+files_dontaudit_all_access_check(readahead_t)
+files_dontaudit_read_security_files(readahead_t)
+files_dontaudit_read_all_sockets(readahead_t)
+
+ifdef(`hide_broken_symptoms', `
+      files_dontaudit_write_all_files(readahead_t)
+      dev_dontaudit_write_all_chr_files(readahead_t)
+      dev_dontaudit_write_all_blk_files(readahead_t)
+')
 
 fs_getattr_all_fs(readahead_t)
 fs_search_auto_mountpoints(readahead_t)
@@ -66,13 +82,12 @@ fs_read_cgroup_files(readahead_t)
 fs_read_tmpfs_files(readahead_t)
 fs_read_tmpfs_symlinks(readahead_t)
 fs_list_inotifyfs(readahead_t)
+fs_dontaudit_read_tmpfs_blk_dev(readahead_t)
 fs_dontaudit_search_ramfs(readahead_t)
 fs_dontaudit_read_ramfs_pipes(readahead_t)
 fs_dontaudit_read_ramfs_files(readahead_t)
 fs_dontaudit_use_tmpfs_chr_dev(readahead_t)
 
-mcs_file_read_all(readahead_t)
-
 mls_file_read_all_levels(readahead_t)
 
 storage_raw_read_fixed_disk(readahead_t)
@@ -84,13 +99,15 @@ auth_dontaudit_read_shadow(readahead_t)
 init_use_fds(readahead_t)
 init_use_script_ptys(readahead_t)
 init_getattr_initctl(readahead_t)
+# needs to write to /run/systemd/notify
+init_write_pid_socket(readahead_t)
+init_create_pid_dirs(readahead_t)
+init_pid_filetrans(readahead_t, readahead_var_run_t, dir, "readahead")
 
 logging_send_syslog_msg(readahead_t)
 logging_set_audit_parameters(readahead_t)
 logging_dontaudit_search_audit_config(readahead_t)
 
-miscfiles_read_localization(readahead_t)
-
 userdom_dontaudit_use_unpriv_user_fds(readahead_t)
 userdom_dontaudit_search_user_home_dirs(readahead_t)
 
Index: serefpolicy-contrib-20140730/realmd.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/realmd.fc
+++ serefpolicy-contrib-20140730/realmd.fc
@@ -1 +1,5 @@
-/usr/lib/realmd/realmd	--	gen_context(system_u:object_r:realmd_exec_t,s0)
+/usr/lib/realmd/realmd		--	gen_context(system_u:object_r:realmd_exec_t,s0)
+
+/var/cache/realmd(/.*)?			gen_context(system_u:object_r:realmd_var_cache_t,s0)
+
+/var/lib/ipa-client(/.*)?		gen_context(system_u:object_r:realmd_var_lib_t,s0)
Index: serefpolicy-contrib-20140730/realmd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/realmd.if
+++ serefpolicy-contrib-20140730/realmd.if
@@ -1,8 +1,9 @@
-## <summary>Dbus system service which manages discovery and enrollment in realms and domains like Active Directory or IPA.</summary>
+
+## <summary>dbus system service which manages discovery and enrollment in realms and domains like Active Directory or IPA</summary>
 
 ########################################
 ## <summary>
-##	Execute realmd in the realmd domain.
+##	Execute realmd in the realmd_t domain.
 ## </summary>
 ## <param name="domain">
 ## <summary>
@@ -39,3 +40,101 @@ interface(`realmd_dbus_chat',`
 	allow $1 realmd_t:dbus send_msg;
 	allow realmd_t $1:dbus send_msg;
 ')
+
+########################################
+## <summary>
+##	Search realmd cache directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`realmd_search_cache',`
+	gen_require(`
+		type realmd_var_cache_t;
+	')
+
+	allow $1 realmd_var_cache_t:dir search_dir_perms;
+	files_search_var($1)
+')
+
+########################################
+## <summary>
+##	Read realmd cache files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`realmd_read_cache_files',`
+	gen_require(`
+		type realmd_var_cache_t;
+	')
+
+	files_search_var($1)
+	read_files_pattern($1, realmd_var_cache_t, realmd_var_cache_t)
+')
+
+########################################
+## <summary>
+##	Create, read, write, and delete
+##	realmd cache files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`realmd_manage_cache_files',`
+	gen_require(`
+		type realmd_var_cache_t;
+	')
+
+	files_search_var($1)
+	manage_files_pattern($1, realmd_var_cache_t, realmd_var_cache_t)
+')
+
+########################################
+## <summary>
+##	Manage realmd cache dirs.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`realmd_manage_cache_dirs',`
+	gen_require(`
+		type realmd_var_cache_t;
+	')
+
+	files_search_var($1)
+	manage_dirs_pattern($1, realmd_var_cache_t, realmd_var_cache_t)
+')
+
+
+########################################
+## <summary>
+##	Read realmd tmp files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`realmd_read_tmp_files',`
+	gen_require(`
+		type realmd_tmp_t;
+	')
+
+	files_search_var($1)
+	read_files_pattern($1, realmd_tmp_t, realmd_tmp_t)
+')
+
Index: serefpolicy-contrib-20140730/realmd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/realmd.te
+++ serefpolicy-contrib-20140730/realmd.te
@@ -7,47 +7,89 @@ policy_module(realmd, 1.1.0)
 
 type realmd_t;
 type realmd_exec_t;
-init_system_domain(realmd_t, realmd_exec_t)
+init_daemon_domain(realmd_t, realmd_exec_t)
+application_domain(realmd_t, realmd_exec_t)
+role system_r types realmd_t;
+
+type realmd_tmp_t;
+files_tmp_file(realmd_tmp_t)
+
+type realmd_var_cache_t;
+files_type(realmd_var_cache_t)
+
+type realmd_var_lib_t;
+files_type(realmd_var_lib_t)
 
 ########################################
 #
-# Local policy
+# realmd local policy
 #
 
-allow realmd_t self:capability sys_nice;
+allow realmd_t self:capability { sys_nice };
+allow realmd_t self:capability2 block_suspend;
 allow realmd_t self:process setsched;
+allow realmd_t self:key manage_key_perms;
+
+manage_dirs_pattern(realmd_t, realmd_tmp_t, realmd_tmp_t)
+manage_files_pattern(realmd_t, realmd_tmp_t, realmd_tmp_t)
+files_tmp_filetrans(realmd_t, realmd_tmp_t, { dir file })
+
+manage_files_pattern(realmd_t, realmd_var_cache_t, realmd_var_cache_t)
+manage_dirs_pattern(realmd_t, realmd_var_cache_t, realmd_var_cache_t)
+
+manage_dirs_pattern(realmd_t, realmd_var_lib_t, realmd_var_lib_t)
+manage_files_pattern(realmd_t, realmd_var_lib_t, realmd_var_lib_t)
+files_var_lib_filetrans(realmd_t, realmd_var_lib_t, dir)
 
 kernel_read_system_state(realmd_t)
+kernel_read_network_state(realmd_t)
 
 corecmd_exec_bin(realmd_t)
 corecmd_exec_shell(realmd_t)
 
-corenet_all_recvfrom_unlabeled(realmd_t)
-corenet_all_recvfrom_netlabel(realmd_t)
-corenet_tcp_sendrecv_generic_if(realmd_t)
-corenet_tcp_sendrecv_generic_node(realmd_t)
-
-corenet_sendrecv_http_client_packets(realmd_t)
 corenet_tcp_connect_http_port(realmd_t)
-corenet_tcp_sendrecv_http_port(realmd_t)
+corenet_tcp_connect_ldap_port(realmd_t)
+corenet_tcp_connect_smbd_port(realmd_t)
 
 domain_use_interactive_fds(realmd_t)
 
 dev_read_rand(realmd_t)
 dev_read_urand(realmd_t)
 
-fs_getattr_all_fs(realmd_t)
+files_manage_etc_files(realmd_t)
 
-files_read_usr_files(realmd_t)
+fs_getattr_all_fs(realmd_t)
 
 auth_use_nsswitch(realmd_t)
 
+init_filetrans_named_content(realmd_t)
+
+logging_manage_generic_logs(realmd_t)
 logging_send_syslog_msg(realmd_t)
 
+miscfiles_manage_generic_cert_files(realmd_t)
+
+seutil_domtrans_setfiles(realmd_t)
+seutil_read_file_contexts(realmd_t)
+
+sysnet_dns_name_resolve(realmd_t)
+systemd_exec_systemctl(realmd_t)
+
+#userdom_admin_home_dir_filetrans(realmd_t, cache_home_t, dir, ".cache")
+#userdom_user_home_dir_filetrans(realmd_t, cache_home_t, dir, ".cache")
+
+optional_policy(`
+	authconfig_domtrans(realmd_t)
+')
+
 optional_policy(`
 	dbus_system_domain(realmd_t, realmd_exec_t)
 
 	optional_policy(`
+		certmonger_dbus_chat(realmd_t)
+	')
+
+	optional_policy(`
 		networkmanager_dbus_chat(realmd_t)
 	')
 
@@ -63,21 +105,40 @@ optional_policy(`
 optional_policy(`
 	kerberos_use(realmd_t)
 	kerberos_rw_keytab(realmd_t)
+	kerberos_rw_config(realmd_t)
+	kerberos_filetrans_named_content(realmd_t)
+')
+
+optional_policy(`
+	ntp_domtrans_ntpdate(realmd_t)
+')
+
+optional_policy(`
+	ssh_domtrans(realmd_t)
+	ssh_systemctl(realmd_t)
 ')
 
 optional_policy(`
 	nis_exec_ypbind(realmd_t)
-	nis_initrc_domtrans(realmd_t)
+	nis_systemctl_ypbind(realmd_t)
 ')
 
 optional_policy(`
-	gnome_read_generic_home_content(realmd_t)
+	gnome_read_config(realmd_t)
+	gnome_read_generic_cache_files(realmd_t)
+	gnome_write_generic_cache_files(realmd_t)
+	gnome_manage_cache_home_dir(realmd_t)
+
 ')
 
 optional_policy(`
 	samba_domtrans_net(realmd_t)
 	samba_manage_config(realmd_t)
-	samba_getattr_winbind_exec(realmd_t)
+	samba_getattr_winbind(realmd_t)
+')
+
+optional_policy(`
+	rpm_dbus_chat(realmd_t)
 ')
 
 optional_policy(`
@@ -86,5 +147,27 @@ optional_policy(`
 	sssd_manage_lib_files(realmd_t)
 	sssd_manage_public_files(realmd_t)
 	sssd_read_pid_files(realmd_t)
-	sssd_initrc_domtrans(realmd_t)
+	sssd_systemctl(realmd_t)
+')
+
+optional_policy(`
+	xserver_read_state_xdm(realmd_t)
+')
+
+optional_policy(`
+	unconfined_domain(realmd_t)
+')
+
+#####################################
+#
+# realmd consolehelper local policy
+#
+
+optional_policy(`
+    userhelper_console_role_template(realmd, system_r, realmd_t)
+	authconfig_manage_lib_files(realmd_consolehelper_t)
+
+	oddjob_systemctl(realmd_consolehelper_t)	
+
+	unconfined_domain_noaudit(realmd_consolehelper_t)
 ')
Index: serefpolicy-contrib-20140730/redis.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/redis.fc
+++ serefpolicy-contrib-20140730/redis.fc
@@ -1,9 +1,11 @@
 /etc/rc\.d/init\.d/redis	--	gen_context(system_u:object_r:redis_initrc_exec_t,s0)
 
-/usr/sbin/redis-server	--	gen_context(system_u:object_r:redis_exec_t,s0)
+/usr/lib/systemd/system/redis.*		--	gen_context(system_u:object_r:redis_unit_file_t,s0)
 
-/var/lib/redis(/.*)?	gen_context(system_u:object_r:redis_var_lib_t,s0)
+/usr/sbin/redis-server		--	gen_context(system_u:object_r:redis_exec_t,s0)
 
-/var/log/redis(/.*)?	gen_context(system_u:object_r:redis_log_t,s0)
+/var/lib/redis(/.*)?		gen_context(system_u:object_r:redis_var_lib_t,s0)
 
-/var/run/redis(/.*)?	gen_context(system_u:object_r:redis_var_run_t,s0)
+/var/log/redis(/.*)?		gen_context(system_u:object_r:redis_log_t,s0)
+
+/var/run/redis(/.*)?		gen_context(system_u:object_r:redis_var_run_t,s0)
Index: serefpolicy-contrib-20140730/redis.if
===================================================================
--- serefpolicy-contrib-20140730.orig/redis.if
+++ serefpolicy-contrib-20140730/redis.if
@@ -1,9 +1,224 @@
-## <summary>Advanced key-value store.</summary>
+## <summary>Advanced key-value store</summary>
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an redis environment.
+##	Execute redis server in the redis domin.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`redis_domtrans',`
+	gen_require(`
+		type redis_t, redis_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, redis_exec_t, redis_t)
+')
+
+########################################
+## <summary>
+##	Execute redis server in the redis domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`redis_initrc_domtrans',`
+	gen_require(`
+		type redis_initrc_exec_t;
+	')
+
+	init_labeled_script_domtrans($1, redis_initrc_exec_t)
+')
+
+########################################
+## <summary>
+##	Read redis's log files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`redis_read_log',`
+	gen_require(`
+		type redis_log_t;
+	')
+
+	logging_search_logs($1)
+	read_files_pattern($1, redis_log_t, redis_log_t)
+')
+
+########################################
+## <summary>
+##	Append to redis log files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`redis_append_log',`
+	gen_require(`
+		type redis_log_t;
+	')
+
+	logging_search_logs($1)
+	append_files_pattern($1, redis_log_t, redis_log_t)
+')
+
+########################################
+## <summary>
+##	Manage redis log files
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`redis_manage_log',`
+	gen_require(`
+		type redis_log_t;
+	')
+
+	logging_search_logs($1)
+	manage_dirs_pattern($1, redis_log_t, redis_log_t)
+	manage_files_pattern($1, redis_log_t, redis_log_t)
+	manage_lnk_files_pattern($1, redis_log_t, redis_log_t)
+')
+
+########################################
+## <summary>
+##	Search redis lib directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`redis_search_lib',`
+	gen_require(`
+		type redis_var_lib_t;
+	')
+
+	allow $1 redis_var_lib_t:dir search_dir_perms;
+	files_search_var_lib($1)
+')
+
+########################################
+## <summary>
+##	Read redis lib files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`redis_read_lib_files',`
+	gen_require(`
+		type redis_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	read_files_pattern($1, redis_var_lib_t, redis_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Manage redis lib files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`redis_manage_lib_files',`
+	gen_require(`
+		type redis_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_files_pattern($1, redis_var_lib_t, redis_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Manage redis lib directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`redis_manage_lib_dirs',`
+	gen_require(`
+		type redis_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_dirs_pattern($1, redis_var_lib_t, redis_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Read redis PID files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`redis_read_pid_files',`
+	gen_require(`
+		type redis_var_run_t;
+	')
+
+	files_search_pids($1)
+	read_files_pattern($1, redis_var_run_t, redis_var_run_t)
+')
+
+########################################
+## <summary>
+##	Execute redis server in the redis domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`redis_systemctl',`
+	gen_require(`
+		type redis_t;
+		type redis_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+    systemd_read_fifo_file_passwd_run($1)
+	allow $1 redis_unit_file_t:file read_file_perms;
+	allow $1 redis_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, redis_t)
+')
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an redis environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -20,7 +235,7 @@
 interface(`redis_admin',`
 	gen_require(`
 		type redis_t, redis_initrc_exec_t, redis_var_lib_t;
-		type redis_log_t, redis_var_run_t;
+		type redis_log_t, redis_var_run_t, redis_unit_file_t;
 	')
 
 	allow $1 redis_t:process { ptrace signal_perms };
@@ -39,4 +254,13 @@ interface(`redis_admin',`
 
 	files_search_pids($1)
 	admin_pattern($1, redis_var_run_t)
+
+	redis_systemctl($1)
+	admin_pattern($1, redis_unit_file_t)
+	allow $1 redis_unit_file_t:service all_service_perms;
+
+	optional_policy(`
+		systemd_passwd_agent_exec($1)
+		systemd_read_fifo_file_passwd_run($1)
+	')
 ')
